# -*- coding: utf-8 -*-
#------------------------------------------------------------------------------
# file: $Id$
# auth: metagriffin <mg.github@uberdev.org>
# date: 2013/10/16
# copy: (C) Copyright 2013-EOT metagriffin -- see LICENSE.txt
#------------------------------------------------------------------------------
# This software is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This software is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see http://www.gnu.org/licenses/.
#------------------------------------------------------------------------------

from __future__ import absolute_import

import time

#------------------------------------------------------------------------------
def now():
  return time.time()

#------------------------------------------------------------------------------
def ts(t=None):
  'returns a timestamp string in the format "YYYYMMDDTHHMMSSZ".'
  if t is None:
    t = time.time()
  return time.strftime('%Y%m%dT%H%M%SZ', time.gmtime(t))

#------------------------------------------------------------------------------
def tsl(t=None):
  'returns a "long" version of ts(), ie in the format "YYYY-MM-DDTHH:MM:SSZ".'
  if t is None:
    t = time.time()
  return time.strftime('%Y-%m-%dT%H:%M:%SZ', time.gmtime(t))

#------------------------------------------------------------------------------
def ts_iso(t=None):
  '''
  returns the same as datetime.datetime.utcfromtimestamp(t).isoformat(),
  except it forces the timezone offset to be displayed (as +00:00).
  '''
  if t is None:
    t = time.time()
  return time.strftime('%Y-%m-%dT%H:%M:%S+00:00', time.gmtime(t))

#------------------------------------------------------------------------------
# end of $Id$
#------------------------------------------------------------------------------
